; does 10 iterations of 10M loops each, using random DWORD input values 

    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap:none        ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
;    include \masm32\include\msvcrt.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
;    includelib \masm32\lib\msvcrt.lib

    include \masm32\macros\macros.asm

    include timers.asm

    LOOP_COUNT EQU 10000000             ; 10M code loops per iteration
    
    .data
      cycles    DB  " cycles",13,10,0   ; end-of-string text
      iter      DB  10                  ; number of 10M-loop iterations
    .data?
      random    DD  ?                   ; to hold random values
    
    .code

start: 
; ---------------------------------------------------------------
    print chr$("Random number samples: ")
    .while iter > 5
    invoke GetTickCount                 ; get system uptime
    invoke nrandom, eax                 ; randomize it
    print ustr$(eax)                    ; display it
    print chr$(" ")                     ; and a space
    sub iter,1                          ; decreate counter
    .endw                               ; only show five random numbers
    print chr$(13,10,13,10)             ; CR+LF x 2
    mov [iter],10                       ; reset counter

; ---------------------------------------------------------------
    print chr$("CPU Square Root Factoring: ")
    .repeat 
    invoke GetTickCount                 ; get system uptime as seed
    invoke nrandom, eax                 ; randomize it
    mov random, eax                     ; save

    
    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      push random                       ; use the random value
      xor ecx, ecx
      xor eax, eax
      bsr edx, [esp]
      and edx, -2 ; even
      bts ecx, edx
  s0: add eax, ecx
      sub [esp], eax
      jnc s1
      add [esp], eax
      sub eax, ecx
      jmp s2

  s1: add eax, ecx
  s2: shr eax, 1
      shr ecx, 2
      jne s0
      pop eax
    counter_end

    
    print ustr$(eax)                    ; add commas and loop
    sub [iter],1
    jz @F
    print chr$(",")
@@:
    .until iter == 0
    
    mov [iter], 10                      ; done looping, reset counter
    print addr cycles                   ; print end-of-line text

; ---------------------------------------------------------------    
    print chr$("FPU Square Root Factoring: ")
    .repeat 
    invoke GetTickCount                 ; get system uptime
    invoke nrandom, eax                 ; randomize it
    mov random, eax                     ; save


    counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
      push random                       ; use the random value
      fwait
      fild dword ptr [esp]
      fsqrt
      fistp dword ptr [esp]
      fwait
      pop eax
    counter_end

    
    print ustr$(eax)                    ; add commas and loop
    sub [iter],1
    jz @F
    print chr$(",")
@@:
    .until iter == 0
    
    mov [iter], 10                      ; done looping, reset counter
    print addr cycles

    mov   eax, input(13,10,"Press ENTER to exit... ")
    exit
; ---------------------------------------------------------------
end start
